// ----------------------------
// Satchel Charges - by v3x
// AMXX owns you! ><
// Email: slayerized@gmail.com
// ----------------------------

// Credits:									[]
// Credit goes to xeroblood for the movement detection and various ideas	||
// Credit goes to KleeneX for various message parameters			[]
// Credit goes to knekter for the model idea					||
// Credit goes to twisted for the button idea					[]
// Credit goes to me for making this plugin :D					||
// Credit goes to AMXX for being so fantasicly uber 1337			[]

// Look in the plugin_init() for cvars/commands					

#include <amxmodx>	// Core		[ ]
#include <amxmisc>	// Misc		[ ]
#include <cstrike>	// Cstrike	[*]
#include <engine>	// Engine	[*]
#include <fun>		// Fun		[*]
// * Required modules

#define	PLUGIN		"Satchel Charges"
#define	VERSION		"1.2"
#define AUTHOR		"v3x"

// -------------------------------------
// Access level required for admin cmds ( toggle cmd / bomb num cmd )
#define	ACCESS_LEVEL	ADMIN_LEVEL_A
// -------------------------------------
// Max players
#define MAX_PLAYERS	32
// -------------------------------------
// TaskID for planting
#define PLANT_TASK_ID	1337
// -------------------------------------
// TaskID for detonating
#define DET_TASK_ID	7331
// -------------------------------------
// Stuff for explosion
#define TE_EXPLOSION	3
#define	TE_SMOKE	5
#define TE_DLIGHT	27
#define TE_BEAMCYLINDER	21
// -------------------------------------
// Stuff for animations
#define SATCH_SEQ_FIRE		4
#define DETON_SEQ_FIRE		4
#define SATCH_SEQ_PICKUP	3
// -------------------------------------
// Time interval for model checking
#define MODEL_FREQ		0.7
// ** SETTING THIS LOWER MAY CAUSE LAG! **
// -------------------------------------
// Amount of satchels the player has
new g_iPlayerBombs[MAX_PLAYERS]
// -------------------------------------
// When user has planted = true, else false
new bool:g_bHasPlanted[MAX_PLAYERS] = false
// -------------------------------------
// For use with detonator stuff
new bool:g_bHasDet[MAX_PLAYERS] = true
// -------------------------------------
// Var to fix the bug in round end..
new bool:g_bHasEnded = false
// -------------------------------------
// For progress bar
new g_iMsgBarTime
// -------------------------------------
// Banned maps file
new g_szBanFile[] = "sc_banned.ini"
// -------------------------------------
// Satchel model ( world )
new g_szBombMdlW[] = "models/w_satchel.mdl"
// -------------------------------------
// Detonator models ( v / p )
new g_szDetMdl[2][] = {"models/v_satchel_radio.mdl","models/p_satchel_radio.mdl"}
// -------------------------------------
// Satchel models ( v / p / w? )
new g_szBombMdl[3][] = {"models/v_satchel.mdl","models/p_satchel.mdl","models/w_satchelt.mdl"}
// -------------------------------------
// Explosion sound
new g_szBombSnd[3][] = {"weapons/explode3.wav","weapons/explode4.wav","weapons/explode5.wav"}
// -------------------------------------
// Player hit sounds
new g_szScrmSnd[3][] = {"player/bhit_flesh-1.wav","player/bhit_flesh-2.wav","player/bhit_flesh-3.wav"}
// -------------------------------------
// Detonate beep sound
new g_szDetonateSnd[] = "fvox/beep.wav"
// -------------------------------------
// Plant sound
new g_szPlantSnd[] = "buttons/button6.wav"
// -------------------------------------
// Pickup sound
new g_szPickupSnd[] = "items/gunpickup2.wav"
// -------------------------------------
// Sprite vars
new explode,smoke,white
// -------------------------------------
// Menu Stuff
#define MAX_CVARS	64	// Maximum number of CVARs in file (may be increased)
#define MAX_CVAR_VALS	20	// Maximum number of options per CVAR (may be increased)
#define MENU_DISPLAY	8

new g_szCvarFile[128]		// The file full of CVAR names and values

// Parallel Arrays: Cvar Name/Values
// (One menu is made from CVAR Names, the chosen Index is then used to build the next 
//  Menu of CVAR Values)
new g_szCvarName[MAX_CVARS][64]
new g_szCvarVals[MAX_CVARS][128]

new g_iCvarCount = 0		// CVAR Counter to track how many CVARs are loaded from file
new g_bCvarFileError = false	// CVAR File Error: If File fails to load any CVARs (or file can't be found)

// Menu Trackers (uses arrays to track multiple admin menus at the same time)
new g_iMenuPosition[MAX_PLAYERS] = 0
new g_iMenuNameIdx[MAX_PLAYERS] = 0
// -------------------------------------

// Check our modules
public plugin_modules()
{
	require_module("cstrike")
	require_module("engine")
	require_module("fun")
}

// Precache required files ( holy moly! ;o )
public plugin_precache()
{
	// Detonator Models
	precache_model(g_szDetMdl[0])
	precache_model(g_szDetMdl[1])

	// Bomb models
	precache_model(g_szBombMdl[0])
	precache_model(g_szBombMdl[1])
	precache_model(g_szBombMdl[2])

	// Bomb world model
	precache_model(g_szBombMdlW)

	// Explosion sounds
	precache_sound(g_szBombSnd[0])
	precache_sound(g_szBombSnd[1])
	precache_sound(g_szBombSnd[2])

	// Player hit sounds
	precache_sound(g_szScrmSnd[0])
	precache_sound(g_szScrmSnd[1])
	precache_sound(g_szScrmSnd[2])

	// Detonator beeping sound
	precache_sound(g_szDetonateSnd)

	// Bomb plant sound
	precache_sound(g_szPlantSnd)
	
	// Pickup sound
	precache_sound(g_szPickupSnd)

	// Sprites
	smoke =   precache_model("sprites/steam1.spr")
	explode = precache_model("sprites/zerogxplode.spr")
	white =   precache_model("sprites/white.spr")
}

public plugin_init()
{
	register_plugin(PLUGIN,VERSION,AUTHOR)

	// Events
	register_logevent("Event_RoundStart",2,"0=World triggered","1=Round_Start")
	register_logevent("Event_RoundEnd",2,"0=World triggered","1=Round_End")
	register_event("TextMsg","Event_Commence","a","2&#Game_C","2&#Game_w")
	register_event("DeathMsg","Event_DeathMsg","a")

	// Plugin toggle command
	register_clcmd("charge_toggle","Cmd_Toggle",ACCESS_LEVEL,"- Turns charges on/off")

	// Count the total # of remote bombs that are setup
	register_clcmd("charge_num","Cmd_CountBombs",ACCESS_LEVEL,"- Counts planted charges")
	
	// Admin CVAR menu commands
	register_clcmd("sc_menu","Cmd_CvarMenu",ADMIN_CVAR,"- Displays CVAR Menu for SC")
	register_clcmd("scmenu","Cmd_CvarMenu",ADMIN_CVAR,"- Displays CVAR Menu for SC")
	
	// Test thinger
	register_srvcmd("sc_status","Cmd_Status")
	
	// Registered Menus for CVAR control
	register_menucmd(register_menuid("\y[SC] CVAR Menu"),1023,"Menu_CvarName")
	register_menucmd(register_menuid("\y[SC] CVAR Options"),1023,"Menu_CvarVals")

	// Client commands
	register_clcmd("buycharge",		"Cmd_BuyBomb")	// Command for buying
	register_clcmd("say /buycharge",	"Cmd_BuyBomb")	// ''
	register_clcmd("say_team /buycharge",	"Cmd_BuyBomb")	// ''
	register_clcmd("say /chargehelp",	"Cmd_ShowHelp")	// Command for help MOTD
	register_clcmd("say chargehelp",	"Cmd_ShowHelp") // ''
	register_clcmd("say_team /chargehelp",	"Cmd_ShowHelp") // ''
	register_clcmd("say_team chargehelp",	"Cmd_ShowHelp") // ''
	register_clcmd("drop",			"Cmd_DropItem") // Used for dropping detonator
	
	// Cvars
	register_cvar("amxx_charge_active",	"1")		// Turns plugin on/off
	register_cvar("amxx_charge_limit",	"3")		// Max bomb limit
	register_cvar("amxx_charge_plant_time",	"2")		// Time taken to plant
	register_cvar("amxx_charge_delay_time",	"1")		// Explosion delay
	register_cvar("amxx_charge_cost",	"500")		// Bomb cost
	register_cvar("amxx_charge_buyzone",	"1")		// Limit to buyzone?
	register_cvar("amxx_charge_radius",	"300")		// Explosion radius
	register_cvar("amxx_charge_damage",	"100")		// Max damage of blast
	register_cvar("amxx_charge_killcash",	"300")		// Kill cash
	register_cvar("amxx_charge_dmgcash",	"1")		// Give half cash for doing dmg?
	register_cvar("amxx_charge_immunity",	"0")		// Planter immune to own bomb (ff=on)?
	register_cvar("amxx_charge_godmode",	"0")		// Affect players with godmode?
	register_cvar("amxx_charge_deathdrop",	"1")		// Drop charges on death?

	// Check Weapon models
	set_task(MODEL_FREQ,"CheckModels",_,_,_,"b")

	// For progress bar
	g_iMsgBarTime = get_user_msgid("BarTime")

	// Check banned map file
	CheckBanned()

	// End of plugin init.
}

public plugin_cfg()
{
	new szBase[128]
	get_configsdir( szBase, 127 )
	format( g_szCvarFile, 128, "%s/sc_cvars.ini", szBase )

	// Build CVAR Arrays for Menu
	g_bCvarFileError = !ReadCvarFile()
	
	if(g_bCvarFileError)
	{
		server_print("[SC] CVAR file not found")
		log_amx("[SC] Cvar file not found: %s",g_szCvarFile)
	}
}

public client_connect(id)
{
	g_iPlayerBombs[id] = 0
	g_bHasPlanted[id] = false
	g_bHasDet[id] = true
}

public client_disconnect(id)
{
	g_iPlayerBombs[id] = 0
	g_bHasPlanted[id] = false
	g_bHasDet[id] = true
}

public Cmd_Status()
{
	switch(get_cvar_num("amxx_charge_active"))
	{
		case 1: server_print("[SC] ON")
		case 0: server_print("[SC] OFF")
	}
	
	return PLUGIN_HANDLED
}

///////////////////////////////// - >
// Check the banned maps file //
/////////////////////////////// - >

public CheckBanned()
{
	new szCfgDir[64]
	get_configsdir(szCfgDir,63)
	
	new szFileStr[64]
	format(szFileStr,63,"%s/%s",szCfgDir,g_szBanFile)

	if(file_exists(szFileStr)) 
	{
		new szMapName[64]
		get_mapname(szMapName,63)
	
		new szText[164]
		new nLen=0,nLine=0
		while(read_file(szFileStr,nLine++,szText,163,nLen)) 
		{
			if(szText[0]==';') continue

			if(equali(szText,szMapName))
			{
				set_cvar_num("amxx_charge_active",0)
				server_print("[SC] Banned map: %s",szMapName)
				break;
			}
			else
			{
				set_cvar_num("amxx_charge_active",1)
				server_print("[SC] Allowed map: %s",szMapName)
				break;
			}
		}
	}
	else
	{
		log_amx("[SC] Banned maps file not found!")
	}
}

///////////////////////  - >
// Begin Menu stuff //
///////////////////// - >

public Cmd_CvarMenu(id,level,cid)
{
	if(!cmd_access(id,level,cid,0))
		return PLUGIN_HANDLED

	// Check for CVAR File Error
	if(g_bCvarFileError)
	{
		client_print(id,print_chat,"CVARs failed to load from file: %s",g_szCvarFile)
		return PLUGIN_HANDLED
	}
    
	// Reset Menu Choices for Current Admin
	g_iMenuPosition[id-1] = 0
	g_iMenuNameIdx[id-1] = 0
	
	// Display First Menu to Admin
	ShowMenu_CvarName(id,0)
    
	return PLUGIN_HANDLED
}

///////////////// - >
// First menu //
/////////////// - >

stock ShowMenu_CvarName(id,pos)
{
	new szMenuBody[256]
	new i,iStart,iEnd,iCurrKey = 0
	new iKeys = (1<<9), iLen = format(szMenuBody,255,"\y[SC] CVAR Menu\w^n")

	iStart = pos * MENU_DISPLAY
	iEnd = iStart + MENU_DISPLAY
	if(iEnd > g_iCvarCount) iEnd = g_iCvarCount

	for(i = iStart; i < iEnd; i++)
	{
		iKeys |= (1<<iCurrKey++)
		iLen += format(szMenuBody[iLen],(255-iLen),"%d. %s^n",iCurrKey,g_szCvarName[i])
	}

	if( iEnd != g_iCvarCount )
	{
		iKeys |= (1<<8)
		format(szMenuBody[iLen],(255-iLen),"^n9. More...^n0. %s",(pos)?"Back":"Exit")
	}
	else
		format(szMenuBody[iLen],(255-iLen),"^n0. %s",(pos)?"Back":"Exit")

	show_menu(id,iKeys,szMenuBody)
	return
}

public Menu_CvarName(id,key)
{
	switch(key)
	{
		case 8: ShowMenu_CvarName(id,++g_iMenuPosition[id-1])
		case 9:
		{
			if(g_iMenuPosition[id-1])
				ShowMenu_CvarName(id,--g_iMenuPosition[id-1])
		}
		default:
		{
			g_iMenuNameIdx[id-1] = (g_iMenuPosition[id-1] * MENU_DISPLAY + key)
			ShowMenu_CvarVals(id,g_iMenuPosition[id-1] = 0)
		}
	}
}

////////////////// - >
// Second menu //
//////////////// - >

stock ShowMenu_CvarVals(id,pos)
{
	new szMenuBody[256]
	new i,iStart,iEnd,iCurrKey = 0
	new iKeys = (1<<9), iLen = format(szMenuBody,255,"\y[SC] CVAR Options\w^n")

	new szCvarValues[MAX_CVAR_VALS][32]
	new iValueCount = ExplodeString(szCvarValues,MAX_CVAR_VALS,g_szCvarVals[g_iMenuNameIdx[id-1]],31,' ')

	iLen += format(szMenuBody[iLen],(255-iLen),"for CVAR: \r%s\w^n^n",g_szCvarName[g_iMenuNameIdx[id-1]])
	    
	iStart = pos * MENU_DISPLAY
	iEnd = iStart + MENU_DISPLAY
	if(iEnd > iValueCount) iEnd = iValueCount

	for(i = iStart; i < iEnd; i++)
	{
		iKeys |= (1<<iCurrKey++)
		iLen += format(szMenuBody[iLen],(255-iLen),"%d. %s^n",iCurrKey,szCvarValues[i])
	}

	if(iEnd != iValueCount)
	{
		iKeys |= (1<<8)
		format(szMenuBody[iLen],(255-iLen),"^n9. More...^n0. Back")
	}
	else
		format(szMenuBody[iLen],(255-iLen),"^n0. Back")

	show_menu(id,iKeys,szMenuBody)
	return
}

public Menu_CvarVals(id,key)
{
	switch(key)
	{
		case 8: ShowMenu_CvarVals(id,++g_iMenuPosition[id-1])
		case 9:
		{
			if(g_iMenuPosition[id-1])
				ShowMenu_CvarVals(id,--g_iMenuPosition[id-1])
			else
				ShowMenu_CvarName(id,g_iMenuPosition[id-1] = 0)
		}
		default:
		{
			new iValueIdx = (g_iMenuPosition[id-1] * MENU_DISPLAY + key)
            
			new szCvarValues[MAX_CVAR_VALS][32]
			ExplodeString(szCvarValues,MAX_CVAR_VALS,g_szCvarVals[g_iMenuNameIdx[id-1]],31,' ')
    
			new szCvarCommand[96],szCvarMessage[128]
            
			format(szCvarMessage,127,"'%s' changed to '%s'",g_szCvarName[g_iMenuNameIdx[id-1]],szCvarValues[iValueIdx])
			client_print(id,print_chat,szCvarMessage)
            
	   		ShowMenu_CvarVals(id,g_iMenuPosition[id-1] = 0)
	  
			format(szCvarCommand,95,"%s %s",g_szCvarName[g_iMenuNameIdx[id-1]],szCvarValues[iValueIdx])
			server_cmd(szCvarCommand)
		}
	}
}

////////////////////////// - >
// Update\check models //
//////////////////////// - >

public CheckModels()
{
	if(IsActive())
	{
		new aPlayers[32],iNum,i
		get_players(aPlayers,iNum,"ac")

		for(i = 0; i <= iNum; i++)
		{
			new id = aPlayers[i]
			if(!is_user_connected(id)) continue
			new iClip,iAmmo,iWeapID = get_user_weapon(id,iClip,iAmmo)

			if(iWeapID == 29)
			{
				if(!(g_bHasPlanted[id]) && (g_iPlayerBombs[id] > 0))
				{
					entity_set_string(id,EV_SZ_viewmodel,g_szBombMdl[0])
					entity_set_string(id,EV_SZ_weaponmodel,g_szBombMdl[1])
				}
				else if(g_bHasPlanted[id] || task_exists(id+DET_TASK_ID) || g_bHasDet[id])
				{
					entity_set_string(id,EV_SZ_viewmodel,g_szDetMdl[0])
					entity_set_string(id,EV_SZ_weaponmodel,g_szDetMdl[1])
				}
				else if(!g_bHasDet[id] && (g_iPlayerBombs[id] <= 0))
				{
					entity_set_string(id,EV_SZ_viewmodel,"models/v_knife.mdl")
					entity_set_string(id,EV_SZ_weaponmodel,"models/p_knife.mdl")
				}
				else
				{
					entity_set_string(id,EV_SZ_viewmodel,"models/v_knife.mdl")
					entity_set_string(id,EV_SZ_weaponmodel,"models/p_knife.mdl")
				}
			}
		}
	}
}

////////////////////////// - >
// Get pressed buttons //
//////////////////////// - >

public client_PreThink(id)
{
	if(IsActive())
	{
		if(task_exists(id+PLANT_TASK_ID))
		{
			if(CheckMovement(id))
			{
				remove_task(id+PLANT_TASK_ID)
				client_print(id,print_center,"You must be standing still to plant a remote bomb!")

				message_begin(MSG_ONE,g_iMsgBarTime,{0,0,0},id)
				write_byte( 0 )
				write_byte( 0 )
				message_end()
			}
		}

		new iClip,iAmmo,iWeapID = get_user_weapon(id,iClip,iAmmo)

		if(iWeapID == 29)
		{
			if((get_user_button(id) & IN_ATTACK) && !(get_user_oldbutton(id) & IN_ATTACK))
			{
				Cmd_PlantBomb(id)
			}
			if((get_user_button(id) & IN_ATTACK2) && !(get_user_oldbutton(id) & IN_ATTACK2)) 
			{
				Cmd_Detonate(id)
			}
			if((get_user_button(id) & IN_RELOAD) && !(get_user_oldbutton(id) & IN_RELOAD)) 
			{
				// Using it this way may be buggy..
				Cmd_BuyBomb(id)
			}
		}
	}
}

///////////////////// - >
// Toggle command //
/////////////////// - >

public Cmd_Toggle(id,level,cid)
{
	if(!cmd_access(id,level,cid,1))
		return PLUGIN_HANDLED

	new iActive = get_cvar_num("amxx_charge_active")
	switch(iActive)
	{
		case 0:
		{
			set_cvar_num("amxx_charge_active",1)
			ResetStuff()
			set_cvar_num("sv_restartround",1)
			console_print(id,"Remote bombs: activated")
		}
		case 1:
		{
			set_cvar_num("amxx_charge_active",0)
			ResetStuff()
			set_cvar_num("sv_restartround",1)
			console_print(id,"Remote bombs: disabled")
		}
	}

	return PLUGIN_HANDLED
}

//////////////////////////// - >
// Count planted charges //
////////////////////////// - >

public Cmd_CountBombs(id,level,cid)
{
	if(!IsActive()) return PLUGIN_HANDLED

	if(!cmd_access(id,level,cid,1))
		return PLUGIN_HANDLED

	new iNum = 0
	new eID
	new szUserName[32]

	for(new x = 0; x < MaxEnts(); x++)
	{
		if(!is_valid_ent(x)) continue

		eID = entity_get_int(x,EV_ENT_owner)

		new szClass[32]
		entity_get_string(x,EV_SZ_classname,szClass,31)
		if(equali(szClass,"remote_bomb"))
		{
			if(is_user_connected(eID))
			{
				get_user_name(eID,szUserName,31)
				console_print(id,"- Bomb [%i]: %s",iNum+1,szUserName)
			}

			iNum++
		}
	}

	console_print(id,"Total Remote Bombs: %i",iNum)

	return PLUGIN_HANDLED
}	

////////////////////// - >
// Buy the charges //
//////////////////// - >

public Cmd_BuyBomb(id)
{
	if(!IsActive()) return PLUGIN_HANDLED

	if((get_cvar_num("amxx_charge_buyzone")) && !(cs_get_user_buyzone(id)))
	{
		client_print(id,print_center,"You must be in a buyzone to buy satchel charges!")
		return PLUGIN_HANDLED
	}

	if(!is_user_alive(id))
	{
		client_print(id,print_center,"The dead can't buy satchel charges!")
		return PLUGIN_HANDLED
	}

	new iCost = get_cvar_num("amxx_charge_cost")
	new iMax = get_cvar_num("amxx_charge_limit")
	new iMoney = cs_get_user_money(id)

	if(iCost > iMoney)
	{
		client_print(id,print_center,"You don't have enough money for a satchel charge!")
		return PLUGIN_HANDLED
	}

	if(g_iPlayerBombs[id] >= iMax)
	{
		client_print(id,print_center,"Max charge limit reached! [%i/%i]",g_iPlayerBombs[id],iMax)
		return PLUGIN_HANDLED
	}

	g_iPlayerBombs[id]++

	cs_set_user_money(id,iMoney-iCost,1)
	client_print(id,print_center,"[%i/%i] charges bought",g_iPlayerBombs[id],iMax)
	
	return PLUGIN_HANDLED
}

///////////////////// - >
// Drop detonator //
/////////////////// - >

public Cmd_DropItem(id)
{
	if(!IsActive()) return PLUGIN_CONTINUE

	new iClip,iAmmo,iWeapID = get_user_weapon(id,iClip,iAmmo)

	if(iWeapID == 29)
	{
		if(is_user_alive(id) && g_bHasDet[id])
		{
			DropDet(id)
		}
	}
	
	return PLUGIN_CONTINUE
}

////////////////////// - >
// Round End event //
//////////////////// - >

public Event_RoundEnd()
{
	if(IsActive())
	{
		ResetStuff()
		g_bHasEnded = true
	}
}

////////////////////////// - >
// Game commence event //
//////////////////////// - >

public Event_Commence()
{
	ResetStuff()
	new aPlayers[32],iNum,x
	get_players(aPlayers,iNum)
	for(x = 0; x <= iNum; x++)
	{
		new id = aPlayers[x]
		if(!is_user_connected(id)) continue
		g_iPlayerBombs[id] = 0
		g_bHasDet[id] = true
	}
}

//////////////////////// - >
// Round Start event //
////////////////////// - >

public Event_RoundStart()
{
	if(IsActive())
	{
		ResetStuff()
		
		g_bHasEnded = false
		
		new aPlayers[32],iNum,x
		get_players(aPlayers,iNum)
		
		for(x = 0; x <= iNum; x++)
		{
			new id = aPlayers[x]
			if(!is_user_connected(id)) continue

			g_bHasDet[id] = true
			
			client_print(id,print_chat,"-/// For help with Satchel Charges, say /chargehelp !! ///-")
		}
	}
}

////////////////// - >
// Death stuff //
//////////////// - >

public Event_DeathMsg()
{
	if(IsActive())
	{
		new eID,id = read_data(2)

		if(task_exists(id+PLANT_TASK_ID))
			remove_task(id+PLANT_TASK_ID)
		if(task_exists(id+DET_TASK_ID))
			remove_task(id+DET_TASK_ID)

		new ent = -1;
		while((ent = find_ent_by_class(ent , "remote_bomb")) != 0) {
			eID = entity_get_int(ent , EV_ENT_owner);
			if(eID == id) {
				remove_entity(ent);
			}
		}

		new iOrigin[3]
		get_user_origin(id,iOrigin)

		if(g_iPlayerBombs[id] > 0 && get_cvar_num("amxx_charge_deathdrop") > 0)
			DropStuff(id,g_iPlayerBombs[id],iOrigin)
	}
}

///////////////////////////////////////// ->
// Pmg, drop teh bombz when they die! //
/////////////////////////////////////// ->

public DropStuff(id,num,origin[3])
{
	new iBomb = create_entity("info_target")
	if(iBomb == 0) return PLUGIN_CONTINUE

	entity_set_string(iBomb,EV_SZ_classname,"remote_bomb_dead")
	entity_set_model(iBomb,g_szBombMdlW)

	new iHolder[99]
	format(iHolder,98,"%d",num)

	entity_set_string(iBomb,EV_SZ_targetname,iHolder)

	entity_set_size(iBomb,Float:{-2.0,-2.0,-1.0},Float:{2.0,2.0,1.0})

	entity_set_int(iBomb,EV_INT_movetype,MOVETYPE_TOSS)
	entity_set_int(iBomb,EV_INT_solid,SOLID_BBOX)
	
	new iRed=random_num(15,255),iGreen=random_num(15,255),iBlue=random_num(15,255)
	set_rendering(iBomb,kRenderFxGlowShell,iRed,iGreen,iBlue,kRenderNormal,get_cvar_num("glow_shell"))

	new Float:iOrigin[3]
	IVecFVec(origin,iOrigin)

	entity_get_vector(id,EV_VEC_origin,iOrigin)

	entity_set_origin(iBomb,iOrigin)
	entity_set_int(iBomb,EV_ENT_owner,id)

	g_iPlayerBombs[id] = 0

	return PLUGIN_CONTINUE
}

///////////////////// - >
// Drop detonator //
/////////////////// - >

public DropDet(id)
{
	new iDet = create_entity("info_target")
	if(iDet == 0 || !(g_bHasDet[id])) return PLUGIN_HANDLED
	
	if(g_bHasPlanted[id])
	{
		client_print(id,print_center,")[ Active charge detected - Drop request denied ](")
		return PLUGIN_HANDLED
	}

	entity_set_string(iDet,EV_SZ_classname,"remote_bomb_det")
	entity_set_model(iDet,g_szDetMdl[1])

	entity_set_size(iDet,Float:{-2.0,-2.0,-1.0},Float:{2.0,2.0,1.0})

	entity_set_int(iDet,EV_INT_movetype,MOVETYPE_TOSS)
	entity_set_int(iDet,EV_INT_solid,SOLID_BBOX)
	
	new iRed=random_num(15,255),iGreen=random_num(15,255),iBlue=random_num(15,255)
	set_rendering(iDet,kRenderFxGlowShell,iRed,iGreen,iBlue,kRenderNormal,75)

	new Float:iOrigin[3]
	entity_get_vector(id,EV_VEC_origin,iOrigin)
	iOrigin[1] += 30
	entity_set_origin(iDet,iOrigin)

	g_bHasDet[id] = false
	
	return PLUGIN_HANDLED
}

////////////////////////// - >
// Check touching ents //
//////////////////////// - >

public pfn_touch(ptr,ptd)
{
	if(IsActive())
	{
		if(ptr)
		{
			new szClass[32],id,ent,num[99]
			entity_get_string(ptr,EV_SZ_classname,szClass,31)

			if(equal(szClass,"remote_bomb_dead"))
			{
				if(ptd)
				{
					id=ptd,ent=ptr
	
					entity_get_string(ptr,EV_SZ_targetname,num,98)
					
					GiveSatchel(id,ent,str_to_num(num))
				}
			}
			else if(equal(szClass,"remote_bomb_det"))
			{
				if(ptd)
				{
					id=ptd,ent=ptr
					
					if(!g_bHasDet[id])
					{
						client_cmd(id,"spk %s",g_szPickupSnd)
						g_bHasDet[id] = true
						remove_entity(ent)
					}
				}
			}
		}
	}
}

//////////////////////////// - >
// Update satchel count  //
////////////////////////// - >

public GiveSatchel(id,ent,num)
{
	// No need to check if plugin is on

	new iMax = get_cvar_num("amxx_charge_limit")

	if((g_iPlayerBombs[id] + num) > iMax)
	{
		client_cmd(id,"spk ^"%s^"",g_szPickupSnd)
		entity_set_int(id,EV_INT_gaitsequence,SATCH_SEQ_PICKUP)
		g_iPlayerBombs[id] = iMax
		remove_entity(ent)
	}

	else if((g_iPlayerBombs[id]+num) < iMax)
	{
		client_cmd(id,"spk ^"%s^"",g_szPickupSnd)
		entity_set_int(id,EV_INT_gaitsequence,SATCH_SEQ_PICKUP)
		g_iPlayerBombs[id] += num
		remove_entity(ent)
	}
}

////////////////////////////// - >
// Plant the charge part 1 //
//////////////////////////// - >

public Cmd_PlantBomb(id)
{
	if(!IsActive()) return PLUGIN_HANDLED
	if(!g_bHasDet[id]) return PLUGIN_HANDLED

	if(g_iPlayerBombs[id] <= 0)
	{
		if(g_iPlayerBombs[id] < 0)
			g_iPlayerBombs[id] = 0

		client_print(id,print_center,"You have no bombs to plant!")
		return PLUGIN_HANDLED
	}

	if(task_exists(id+PLANT_TASK_ID))
	{
		client_print(id,print_center,"You are currently planting a charge!")
		return PLUGIN_HANDLED
	}

	if(g_bHasPlanted[id])
	{
		client_print(id,print_center,"You have already planted a charge!")
		return PLUGIN_HANDLED
	}

	if(CheckMovement(id))
	{
		client_print(id,print_center,"You must be standing still to plant a charge!")
		return PLUGIN_HANDLED
	}

	if(!is_user_alive(id))
	{
		client_print(id,print_center,"The dead can't plant charges!")
		return PLUGIN_HANDLED
	}

	new pstr[2]
	pstr[0] = id

	new iTime = get_cvar_num("amxx_charge_plant_time")

	set_task(float(iTime),"PlantBomb",(id+PLANT_TASK_ID),pstr,1)

	entity_set_int(id,EV_INT_gaitsequence,SATCH_SEQ_FIRE)

	message_begin(MSG_ONE,g_iMsgBarTime,{0,0,0},id)
	write_byte( iTime )
	write_byte( 0 )
	message_end()

	client_print(id,print_center,"Planting charge...")

	return PLUGIN_HANDLED
}

////////////////////////////// - >
// Plant the charge part 2 //
//////////////////////////// - >

public PlantBomb(pstr[])
{
	new id = pstr[0]

	new iBomb = create_entity("info_target")
	if(iBomb == 0) return PLUGIN_HANDLED
		
	entity_set_string(iBomb,EV_SZ_classname,"remote_bomb")
	entity_set_model(iBomb,g_szBombMdlW)

	entity_set_size(iBomb,Float:{-2.0,-2.0,-1.0},Float:{2.0,2.0,1.0})

	entity_set_int(iBomb,EV_INT_movetype,MOVETYPE_TOSS)
	entity_set_int(iBomb,EV_INT_solid,SOLID_BBOX)

	new Float:iOrigin[3]
	entity_get_vector(id,EV_VEC_origin,iOrigin)
	iOrigin[1] += 25
	entity_set_origin(iBomb,iOrigin)
	entity_set_int(iBomb,EV_ENT_owner,id)

	entity_set_int(id,EV_INT_gaitsequence,DETON_SEQ_FIRE)

	emit_sound(id,CHAN_AUTO,g_szPlantSnd,1.0,ATTN_NORM,0,PITCH_NORM)

	client_print(id,print_center,"Satchel Charge Planted")

	g_bHasPlanted[id] = true

	return PLUGIN_HANDLED
}

/////////////////////////////////////// - >
// Make the charge explode from cmd //
///////////////////////////////////// - >

public Cmd_Detonate(id)
{
	if(!g_bHasDet[id]) return PLUGIN_HANDLED

	if(!g_bHasPlanted[id])
	{
		client_print(id,print_center,"You never planted a satchel charge!")
		return PLUGIN_HANDLED
	}

	if(g_iPlayerBombs[id] <= 0)
	{
		if(g_iPlayerBombs[id] < 0)
			g_iPlayerBombs[id] = 0

		client_print(id,print_center,"You have no satchel charges to detonate!")
		return PLUGIN_HANDLED
	}

	if(!is_user_alive(id))
	{
		client_print(id,print_center,"The dead can't detonate satchel charges!")
		return PLUGIN_HANDLED
	}

	new eID
	new pstr[2]

	new iTime = get_cvar_num("amxx_charge_delay_time")

	new ent = -1;
	while((ent = find_ent_by_class(ent , "remote_bomb")) != 0) {
		eID = entity_get_int(ent , EV_ENT_owner);
		if(is_user_connected(eID) && eID == id) {
			emit_sound(id,CHAN_AUTO,g_szDetonateSnd,1.0,ATTN_NORM,0,PITCH_NORM)
			client_print(id,print_center,"*BEEP*")
			pstr[0] = ent;
			set_task(float(iTime),"BombDamage",(DET_TASK_ID+id),pstr,1)
			break;
		}
	}

	message_begin(MSG_ONE,g_iMsgBarTime,{0,0,0},id)
	write_byte( iTime )
	write_byte( 0 )
	message_end()

	g_bHasPlanted[id] = false

	if(g_iPlayerBombs[id] > 0)
		g_iPlayerBombs[id]--

	return PLUGIN_HANDLED
}

//////////////////////////////// - >
// Charge damage and effects //
////////////////////////////// - >

public BombDamage(pstr[])
{
	if(g_bHasEnded) return PLUGIN_HANDLED

	new eID = pstr[0]
	if(!is_valid_ent(eID)) {
		client_print(0 , print_chat , "* Invalid ENTITY: %i" , eID);
	}
	new id = entity_get_int(eID,EV_ENT_owner)

	new iPlCash = cs_get_user_money(id)

	new aPlayers[32],iNum,x
	get_players(aPlayers,iNum,"a")

	new iRadius = get_cvar_num("amxx_charge_radius")
	new iDamage = get_cvar_num("amxx_charge_damage")
	new iImmune = get_cvar_num("amxx_charge_immunity")
	new iGmode  = get_cvar_num("amxx_charge_godmode")
	new iCash   = get_cvar_num("amxx_charge_killcash")
	new iBonus  = get_cvar_num("amxx_charge_dmgcash")
	new iFfire  = get_cvar_num("mp_friendlyfire")

	new Float:fOrigin[3]
	new iOrigin[3]

	for(x = 0; x <= iNum; x++) {
		new i = aPlayers[x]
		if(!is_user_connected(i)) continue
		new iGod  = get_user_godmode(i)

		if(!is_user_connected(i) 
		|| ((iImmune > 0) && (id == i)) 
		|| ((iGmode > 0) && (iGod > 0))) continue

		new iDist = floatround(entity_range(eID,i))

		if(iDist <= iRadius) {
			new iHealth = get_user_health(i)

			if(iFfire) {
				if((iHealth-iDamage) <= 0) {
					user_silentkill(i)
					make_deathmsg(id,i,0,"grenade")
					set_user_frags(id,get_user_frags(id)+1)
					cs_set_user_money(id,iPlCash+iCash)
				}
				else {
					set_user_health(i,iHealth-iDamage)
					
					if(get_user_team(id) != get_user_team(i)) {
						if(iBonus)
							cs_set_user_money(id,(iPlCash+(iCash/2)),1)
					}
				}
			}

			if(!iFfire) {
				if((iHealth-iDamage) <= 0) {
					if(get_user_team(id) != get_user_team(i)) {
						user_silentkill(i)
						make_deathmsg(id,i,0,"grenade")
						set_user_frags(id,get_user_frags(id)+1)
						client_cmd(i,"spk ^"%s^"",g_szScrmSnd[random_num(0,2)])
						cs_set_user_money(id,iPlCash+iCash)
					}
				}
				else {
					if(get_user_team(id) != get_user_team(i)) {
						set_user_health(i,iHealth-iDamage)
						client_cmd(i,"spk ^"%s^"",g_szScrmSnd[random_num(0,2)])

						if(iBonus)
							cs_set_user_money(id,(iPlCash+(iCash/2)),1)
					}
				}
			}

			new nOrigin[3]
			get_user_origin(i,nOrigin)

			// Lighted area effect
			message_begin( MSG_ONE,SVC_TEMPENTITY,{0,0,0},i )
			write_byte ( TE_DLIGHT )
			write_coord( nOrigin[0] )
			write_coord( nOrigin[1] )
			write_coord( nOrigin[2] )
			write_byte ( 200 )
			write_byte ( 255 )
			write_byte ( 255 )
			write_byte ( 25 )
			write_byte ( 5 )
			write_byte ( 5 )
			message_end() 
		}
	}

	emit_sound(eID,CHAN_AUTO,g_szBombSnd[random_num(0,2)],1.0,ATTN_NORM,0,PITCH_NORM)

	entity_get_vector(eID,EV_VEC_origin,fOrigin)
	FVecIVec(fOrigin,iOrigin)

	// Explosion
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY,iOrigin )
	write_byte ( TE_EXPLOSION )
	write_coord( iOrigin[0] )
	write_coord( iOrigin[1] )
	write_coord( iOrigin[2] )
	write_short( explode )
	write_byte ( 30 )
	write_byte ( 15 )
	write_byte ( 0 )
	message_end()

	// Smoke
	message_begin( MSG_BROADCAST,SVC_TEMPENTITY,iOrigin )
	write_byte ( TE_SMOKE )
	write_coord( iOrigin[0] )
	write_coord( iOrigin[1] )
	write_coord( iOrigin[2] )
	write_short( smoke )
	write_byte ( 100 )
	write_byte ( 15 )
	message_end()
	
	// Ring effect
	message_begin( MSG_ALL,SVC_TEMPENTITY,iOrigin )
	write_byte ( TE_BEAMCYLINDER )
	write_coord( iOrigin[0] )
	write_coord( iOrigin[1] )
	write_coord( iOrigin[2] )
	write_coord( iOrigin[0] )
	write_coord( iOrigin[1] )
	write_coord( iOrigin[2]+200 )
	write_short( white )
	write_byte ( 0 )
	write_byte ( 1 )
	write_byte ( 6 )
	write_byte ( 8 )
	write_byte ( 1 )
	write_byte ( 255 )
	write_byte ( 255 )
	write_byte ( 192 )
	write_byte ( 128 )
	write_byte ( 5 )
	message_end()

	remove_entity(eID)

	return PLUGIN_HANDLED
}

///////////////////////////////// - >
// Remove all charge entities //
/////////////////////////////// - >

public ResetStuff()
{
	if(IsActive())
	{
		new const num = MaxEnts();
		for(new x = -1; x <= num; x++) {
			if(!is_valid_ent(x)) continue
			new szClass[32]
			entity_get_string(x,EV_SZ_classname,szClass,31)

			if(equal(szClass,"remote_bomb") 
			|| equal(szClass,"remote_bomb_dead") 
			|| equal(szClass,"remote_bomb_det"))
				remove_entity(x)
		}

		new aPlayers[32],iNum,i
		get_players(aPlayers,iNum)

		for(i = 0; i <= iNum; i++)
		{
			new id = aPlayers[i]
			g_bHasPlanted[id] = false
		}
	}
}

////////////////////// - >
// Help file stuff //
//////////////////// - >

public Cmd_ShowHelp(id)
{
	new len,motdMsg[899]

	#if !defined NO_STEAM
		len = format(motdMsg,898,"<html><head><title></title></head><body bgcolor=#3E4637 text=#C4B550>")
		len += format(motdMsg[len],898-len,"<b><u>%s V%s</u> by <i>%s</i></b><br>",PLUGIN,VERSION,AUTHOR)
		len += format(motdMsg[len],898-len,"Allows you to plant remote bombs and blow people up!<br><br>")
		len += format(motdMsg[len],898-len,"<b><u>How to use it</u></b>:<br>")
		len += format(motdMsg[len],898-len,"Get your knife out, say <b>/buycharge</b> or bind a key to '<b>buycharge</b>'.<br>")
		len += format(motdMsg[len],898-len,"Attack is to plant, no need to hold it. Attack2 is to detonate the charge.<br><br>")
		len += format(motdMsg[len],898-len,"You can also pickup other peoples charges when they die by touching the glowing satchel.<br>")
		len += format(motdMsg[len],898-len,"Also, you can drop your detonator, but you cannot plant charges then!<br>")
		len += format(motdMsg[len],898-len,"You will be given a new detonator on round start.<br><br>")
		len += format(motdMsg[len],898-len,"<u><b>Current price</b></u>: $%d<br>",get_cvar_num("amxx_charge_cost"))
		len += format(motdMsg[len],898-len,"<b><u>Current limit: %i</u></b><br><br>",get_cvar_num("amxx_charge_limit"))
		len += format(motdMsg[len],898-len,"Have fun!! - v3x")
	#else
		len = format(motdMsg,898,"%s V%s by %s^n",PLUGIN,VERSION,AUTHOR)
		len += format(motdMsg[len],898-len,"Allows you to plant remote bombs and blow people up!^n^n")
		len += format(motdMsg[len],898-len,"How to use it:^n")
		len += format(motdMsg[len],898-len,"Get your knife out, say /buycharge or bind a key to 'buycharge'.^n")
		len += format(motdMsg[len],898-len,"Attack is to plant, no need to hold it. Attack2 is to detonate the charge.^n^n")
		len += format(motdMsg[len],898-len,"You can also pickup other peoples charges when they die by touching the glowing satchel.^n")
		len += format(motdMsg[len],898-len,"Also, you can drop your detonator, but you cannot plant charges then!^n")
		len += format(motdMsg[len],898-len,"You will be given a new detonator on round start.^n^n")
		len += format(motdMsg[len],898-len,"Current price: $%d^n",get_cvar_num("amxx_charge_cost"))
		len += format(motdMsg[len],898-len,"Current limit: %i^n^n",get_cvar_num("amxx_charge_limit"))
		len += format(motdMsg[len],898-len,"Have fun!! - v3x")
	#endif
	
	show_motd(id,motdMsg,"Satchel Help:")
	
	return PLUGIN_HANDLED
}

//////////////////////// - >
// Get the # of ents // 
////////////////////// - >

stock MaxEnts()
{
	new iEnts = get_global_int(GL_maxEntities)
	return iEnts;
}

///////////////////////// - >
// Get plugin status  // 
/////////////////////// - >

stock bool:IsActive()
{
	if(get_cvar_num("amxx_charge_active"))
		return true
	return false
}

//////////////////////////////// - >
// Check if player is moving // 
////////////////////////////// - >

stock bool:CheckMovement(id)	// xero's :)
{
    if(get_user_button(id)&(IN_JUMP|IN_FORWARD|IN_BACK|IN_MOVELEFT|IN_MOVERIGHT))
        return true
    return false
}

////////////////// - >
// Menu stocks //
//////////////// - >

stock bool:ReadCvarFile()
{
	new iLineLen,iLinePos = 0,szLine[128],szData[2][128],szErrMsg[128]

	if(!file_exists(g_szCvarFile))
	{
		format(szErrMsg,127,"File Error: File '%s' Does Not Exist!",g_szCvarFile)
		server_print(szErrMsg)
		return false
	}

	// Read File
	while(read_file(g_szCvarFile,iLinePos++,szLine,127,iLineLen) && (g_iCvarCount < MAX_CVARS))
	{
		if(szLine[0] == ';' || !iLineLen) continue

		// [0] CVAR Name   [1] CVAR Values
		parse(szLine,szData[0],127,szData[1],127 )
		remove_quotes(szData[1])
        
		// Store Data Globally
		format(g_szCvarName[g_iCvarCount],63,"%s",szData[0])
		format(g_szCvarVals[g_iCvarCount],127,"%s",szData[1])

		// Fix CVAR String Values (Optional)
		//while(replace(g_szCvarVals[g_iCvarCount],127,"\'","^"")) { }

		g_iCvarCount++
	}
	return (g_iCvarCount > 0)
}

stock ExplodeString(p_szOutput[][],p_iMax,p_szInput[],p_iSize,p_szDelimiter)
{
	new iIdx = 0,l = strlen(p_szInput)
	new iLen = (1 + copyc(p_szOutput[iIdx],p_iSize,p_szInput,p_szDelimiter))
	while((iLen < l) && (++iIdx < p_iMax))
		iLen += (1 + copyc(p_szOutput[iIdx],p_iSize,p_szInput[iLen],p_szDelimiter))
	return (iIdx + 1)
}